<script src="@#file#(simpletransf.js)" type="text/javascript"></script>
<p>Smik je linearna transformacija. Smik može djelovati uzduž osi x, uzduž osi y ili kombinirano. Transformacija smika točku (x,y) preslikava u:
\[
 \hat x = x + a \cdot y\\
 \hat y = y + b \cdot x\\
\]
što u matričnom obliku možemo zapisati kao:
\[
[\begin{array}{cc}\hat x &amp; \hat y\end{array}] = 
[\begin{array}{cc}x &amp; y\end{array}] \cdot
\left[ \begin{array}{cc}1 &amp; b\\ a &amp; 1\end{array} \right].
\]   
odnosno ako radimo s točkama u homogenom prostoru, transformaciju možemo zapisati kao afinu transformaciju koristeći samo jednu matricu:
\[
[\begin{array}{ccc}\hat x &amp; \hat y &amp; 1\end{array}] = 
[\begin{array}{ccc}x &amp; y &amp; 1\end{array}] \cdot
\left[ \begin{array}{ccc}1 &amp; b &amp; 0\\ a &amp; 1 &amp; 0\\ 0 &amp; 0 &amp; 1\end{array} \right].
\]
</p>


<div width="500" height="500" style="position:relative; width:500px; margin: auto;">
<canvas id="myCanvas2" width="500" height="500" style="border: 1px solid white;"></canvas>
</div>
<div style="position:relative; width:500px; margin: auto;">
Smik po osi x: <span id="example2_sx">0.3</span><br><input 
  onchange="example2.transform[1][0]=this.valueAsNumber; example2.paint(); document.getElementById('example2_sx').innerHTML=this.value;"
  oninput="example2.transform[1][0]=this.valueAsNumber; example2.paint(); document.getElementById('example2_sx').innerHTML=this.value;"
 type="range" min="-4" max="4" value="0.3" step="0.1"><br>
Smik po osi y: <span id="example2_sy">0.1</span><br><input 
  onchange="example2.transform[0][1]=this.valueAsNumber; example2.paint(); document.getElementById('example2_sy').innerHTML=this.value;"
  oninput="example2.transform[0][1]=this.valueAsNumber; example2.paint(); document.getElementById('example2_sy').innerHTML=this.value;"
 type="range" min="-4" max="4" value="0.1" step="0.1"><br>
</div>
<script type="text/javascript">
  var example2 = new SimpleTransfCanvas("myCanvas2");
  example2.transform[0][0]=1;
  example2.transform[0][1]=0.1;
  example2.transform[1][0]=0.3;
  example2.transform[1][1]=1;
  example2.paint();
</script>

<p>U nastavku je prikazana interaktivna demonstracija koja ilustrira djelovanje smika na geometrijski lik.</p>

<!-- Demonstracija smika -->
@#page-include#(shaders.html)
@#page-include#(shear-sim-hr.html)
<!-- Demonstracija smika -->

<p>Primijetite kako se za neke vrijednosti smika po x i y-osi isti pretvara u kompoziciju rotacije i uniformnog skaliranja. Podesite primjerice da je smik po osi x jednak 1 a smik po osi y jednak -1. Pogledajte najprije dobiveni rezultat: slovo F malo je uvećano i zarotirano za -45°. Zagledate li se pažljivo, uvjerit ćete se da je faktor skaliranja jednak \(\sqrt{2}\). Da bismo se uvjerili da se u ovom slučaju stvarno radi o kompoziciji rotacije i skaliranja, pogledajte kako izgleda aktualna transformacijska matrica (onaj njezin linearni dio - podmatrica 2x2): svi elementi su 1 ili -1 (i negativan je samo jedan - na jednoj od pozicija gdje je u rotacijskoj matrici inače sinus, a na onoj drugoj poziciji je suprotan broj: baš kao što mora biti). Jedino što su norme vektora po stupcima prevelike za rotacijsku matricu: norme stupaca moraju biti 1.</p>
<p>Idemo stoga odrediti normu vektora u oba stupca:
\[
\sqrt{1^2 + 1^2} = \sqrt{1^2 + (-1)^2} = \sqrt{2}.
\]
Iz ovoga vidimo da su oba stupca zapravo neki jedinični vektor skaliran korijenom iz 2. Zbog toga možemo pisati da je transformacijska matrica jednaka:
\[
\left[ \begin{array}{cc} 1 &amp; -1 \\ 1 &amp; 1\end{array} \right] =
\sqrt{2} \cdot \left[ \begin{array}{cc} \frac{1}{\sqrt{2}} &amp; \frac{-1}{\sqrt{2}} \\ \frac{1}{\sqrt{2}} &amp; \frac{1}{\sqrt{2}}\end{array} \right] =
\left[ \begin{array}{cc} \frac{1}{\sqrt{2}} &amp; \frac{-1}{\sqrt{2}} \\ \frac{1}{\sqrt{2}} &amp; \frac{1}{\sqrt{2}}\end{array} \right] \cdot \left[ \begin{array}{cc} \sqrt{2} &amp; 0 \\ 0 &amp; \sqrt{2}\end{array} \right]
\] 
čime smo pokazali da se radi o rotacijskoj matrici koja rotira za kut od -45° pomnoženoj matricom uniformnog skaliranja čiji je faktor skaliranja \(\sqrt{2}\).
</p>
<p>
Uvjerite se za vježbu da smik po x-osi za 4 i po y-osi za -4 također odgovara kompoziciji rotacije i uniformnog skaliranja: ovaj puta rotacija je za kut od poprilici -75.96° a faktor uniformnog skaliranja je \(\sqrt{17}\).
</p>


